% one example to demonstrate the use of function 'Baker3D' and 'iBaker3D'.
% written by Y.B. Mao at Dept. of Automation, NJUST.
% May, 17, 2006
% all rights reserved.
% 
% For the detail of the proposed algorithm, please refer to 
% Yaobin Mao, Guanrong Chen, Shiguo Lian. A Novel Fast Image Encryption Scheme 
% Based on 3D Chaotic Baker Maps. International Journal of Bifurcation and Chaos, 
% Vol. 14, No. 10 (2004) 3613-3624.
%
I = imread('lilies.jpg');
O = double(I);   % convert the matrix to double type.
round = 1;
key = [49 50 51 52 53 54 55 56 57 48 49 50 51 52 53 54]; % set cipher key
E = Baker3D( O, round, key );
Ed = uint8( E );
imshow( Ed );
title('encrypted image');
key = [49 50 51 52 53 54 55 56 57 48 49 50 51 52 53 54];
D = iBaker3D( E, round, key );
Dd = uint8( D );
figure;
imshow( Dd );
title('decrypted image');
% imwrite(Ed,'cipher1.bmp','bmp');