% baker3D: this routine and its counterpart are to perform a chaos based  
% encryption and decryption by use of 3D baker map. This function is for encryption.
% 
% For the detail of the proposed algorithm, please refer to 
% Yaobin Mao, Guanrong Chen, Shiguo Lian. A Novel Fast Image Encryption Scheme 
% Based on 3D Chaotic Baker Maps. International Journal of Bifurcation and Chaos, 
% Vol. 14, No. 10 (2004) 3613-3624.
%
% usage of the function:
% outData = baker3D( inData, round, keyChar )
% where inData can be a vector or matrix to be encrypted, round and keyChar play roles as
% keys which are a scalar and a vector with 16 elements respectively. value
% of round should be chosen in between 1 and 255, and elements of keyChar should be in between 
% 0 and 255, all are integers. Output parameter, outData is also a vector or matrix
% that has the same size with input argument, inData.
% 
% here we give one example:
% the example is to encrypt a standard windows bitmap file
% I = imread('barbara.bmp');
% O = double(I);   % convert the matrix to double type.
% round = 1;
% key = [49 50 51 52 53 54 55 56 57 48 49 50 51 52 53 54]; % set cipher key
% E = baker3D( O, round, key );
% Ed = uint8(E);
% imshow(Ed);
% title('encrypted image');
% 
% This Matlab as well as C++ rountine was Written by Y.B.Mao
% with Department of Automation in NJUST on Aug. 13, 2002.
% Version 1.0, Revised on May 17, 2006.
% All Rights reserved.
% 
% This routine can be arbitary disseminated or modified only for the purpose of
% education.
% 
% Any suggestions, comments and bug reports are welcome. Please send
% email to:  maoyaobin@163.com