% one example to demonstrate the use of function 'catmap3' and 'icatmap3'.
% written by Y.B. Mao at Dept. of Automation, NJUST.
% 
% For the detail of the proposed algorithm, please refer to 
% Guanrong Chen, Yaobin Mao, Charles K. Chui, A Symmetric Image Encryption 
% Scheme Based on Chaotic 3D Cat Maps, Chaos, solitons and fractals,21(2004),
% pp.749-761. 
%
I = imread('lena.bmp');
O = double(I);   % convert the matrix to double type.
round = 1;
key = [49 50 51 52 53 54 55 56 57 48 49 50 51 52 53 54]; % set cipher key
E = catmap3( O, round, key );
Ed = uint8( E );
imshow( Ed );
title('encrypted image');
key = [49 50 51 52 53 54 55 56 57 48 49 50 51 52 53 54];
D = icatmap3( E, round, key );
Dd = uint8( D );
figure;
imshow( Dd );
title('decrypted image');
% imwrite(Ed,'cipher1.bmp','bmp');